/*
 * Copyright (c) 2018-2999 广州亚米信息科技有限公司 All rights reserved.
 *
 * https://www.gz-yami.com/
 *
 * 未经允许，不可做商业用途！
 *
 * 版权所有，侵权必究！
 */

package com.yami.shop.coupon.comment.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.yami.shop.bean.app.dto.CouponDto;
import com.yami.shop.bean.app.dto.CouponOrderDto;
import com.yami.shop.common.util.PageParam;
import com.yami.shop.coupon.comment.model.Coupon;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;
import java.util.Map;

public interface CouponMapper extends BaseMapper<Coupon> {

    Coupon getCouponAndCouponProdsByCouponId(@Param("id") Long id);

    int updateCouponStocksAndVersion(@Param("couponId") Long couponId);

    void updateOverdueStatusByTime(@Param("now") Date now);

    void updatePutonStatusByStocks();

    void putonCoupon(@Param("now") Date now);

    /**
     * 获取通用优惠券列表
     *
     * @return
     */
    List<CouponDto> generalCouponList(@Param("userId") String userId);


    /**
     * 通过优惠券状态获取优惠券列表
     *
     * @param page
     * @param userId
     * @param status
     * @return
     */
    IPage<CouponDto> getCouponListByStatus(IPage<CouponDto> page, @Param("userId") String userId, @Param("status") Integer status);

    List<CouponOrderDto> getCouponListByShopIds(@Param("userId") String userId, @Param("shopId") Long shopId);


    /**
     * 查询需要更新的店铺id列表
     *
     * @param now 当前时间
     * @return
     */
    List<Long> listOverdueStatusShopIds(@Param("now") Date now);

    /**
     * 获取某店铺所有的投放优惠券和优惠商品列表
     *
     * @param shopId
     * @return
     */
    List<Coupon> listPutonCouponAndCouponProdsByShopId(@Param("shopId") Long shopId);

    List<Long> listCouponIdsByUserId(@Param("userId") String userId);

    Map<String, Long> getCouponCountByStatus(@Param("userId") String userId);

    /**
     * 平台  -- 分页获取优惠券数据
     */
    IPage<Coupon> getPlatformPage(@Param("page") PageParam<Coupon> page, @Param("coupon") Coupon coupon);

    /**
     * 更新投放状态
     */
    int updatePutOnStatusByCouponId(@Param("couponId") Long couponId, @Param("status") int status);

    /**
     * 更新投放状态
     */
    int updateOverdueStatusByCouponId(@Param("couponId") Long couponId, @Param("overdueStatus") int overdueStatus);

    List<CouponDto> getCouponList(@Param("couponForAllProd") List<CouponDto> couponForAllProd, @Param("couponForProd") List<Long> couponForProd,
                                  @Param("couponForElseProd") List<CouponDto> couponForElseProd, @Param("userId") String userId);

    IPage<CouponDto> getCouponPageByCouponDto(PageParam<CouponDto> page);
}
